#property indicator_chart_window //   
#property indicator_buffers 2
#property indicator_color1 Red // 
#property indicator_color2 Green // 

//  
extern double Step=0.02; //    
extern double Maximum=0.2; //  

 int History=0; // 0-  

// .
double   SARup[]; // 
double   SARdn[]; // 
bool up_t,dn_t;
//  
bool first=1; //   

int init()
  {
   first=1;
   // 
   SetIndexBuffer(0,SARup);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexEmptyValue(0,0.0);
   SetIndexArrow(0,159);
   // 
   SetIndexBuffer(1,SARdn);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexEmptyValue(1,0.0);
   SetIndexArrow(1,159);

   return(0);
  }

int reinit() // -  
  {
   ArrayInitialize(SARup,0.0);
   ArrayInitialize(SARdn,0.0);
   return(0);
  }

int start()
  {
  
   int ic=IndicatorCounted();
   if(!first && Bars-ic-1>1) ic=reinit(); 
   bool ic0=ic==0;
   int limit=Bars-ic-1; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--) { //     
      bool reset=i==limit && ic==0; //      
      if(reset) {
         static int BarsPrev=0; // -   . 
         static bool dir=0; //  
         static double mid1=0,sar1=0; //  .    .
        }
      bool NewBar=ic0 || BarsPrev!=Bars; //    

      double sar0=iSAR(NULL,0,Step,Maximum, i); // 
      double mid0=(High[i]+Low[i])/2; // . 
      //    
      bool up=sar1>=mid1 && sar0<mid0; //  
      bool dn=sar1<=mid1 && sar0>mid0; //  
      //  
      if(up) dir=1; // 
      if(dn) dir=0; // 
      if (up!=up_t || dn!=dn_t) {Alert("");Print("");}  
      up_t=up;
      dn_t=dn;
      //  
      if(dir) {
         SARdn[i]=sar0;
         SARup[i]=0.0;
        }
      else {
         SARup[i]=sar0;
         SARdn[i]=0.0;
        }
      // 
      if(NewBar) {BarsPrev=Bars; mid1=mid0; sar1=sar0;}
     }   
   first=0; //    
   return(0);
  }

